-- by mor2000

PushObjectRaycastEvent = {}
PushObjectRaycastEvent_mt = Class(PushObjectRaycastEvent, Event)

InitEventClass(PushObjectRaycastEvent, "PushObjectRaycastEvent")

function PushObjectRaycastEvent:emptyNew()
	local self = Event:new(PushObjectRaycastEvent_mt)
	return self
end

function PushObjectRaycastEvent:new(camx, camy, camz, dirx, diry, dirz, rotY)
	local self = PushObjectRaycastEvent:emptyNew()
	self.camx = camx
	self.camy = camy
	self.camz = camz
	self.dirx = dirx
	self.diry = diry
	self.dirz = dirz
	self.rotY = rotY
	return self
end

function PushObjectRaycastEvent:writeStream(streamId, connection)
	if connection.getIsServer(connection) then
		-- send data to server
		streamWriteAuto(streamId, self.camx, self.camy, self.camz, self.dirx, self.diry, self.dirz, self.rotY)
	end
end

function PushObjectRaycastEvent:readStream(streamId, connection)
	if not connection.getIsServer(connection) then
		-- receive data from client
		PushObjectListener:doRaycastForObject(streamReadAuto(streamId))
	end
end

function PushObjectRaycastEvent.sendEvent(camx, camy, camz, dirx, diry, dirz, rotY, alreadySent)
	if not alreadySent then
		if g_server == nil then
			g_client:getServerConnection():sendEvent(PushObjectRaycastEvent:new(camx, camy, camz, dirx, diry, dirz, rotY))
		end
	end
end 
